//-------------------------------------------------------------------------------------------
// Log module.
//-------------------------------------------------------------------------------------------

const SAMFIND_MODLOG_IS_ON = false;

var EXPORTED_SYMBOLS = ["samfind_modlog"];

var samfind_modlog =
{
	_init : function()
	{
		if (SAMFIND_MODLOG_IS_ON)
		{
			dump("\n[samfind]: samfind_modlog::_init()");
		}
  	},

	dump : SAMFIND_MODLOG_IS_ON ?
		function(s)
		{
			dump("\n[samfind]: " + s);
		}
		:
		function(s)
		{
		},

	dump_exception : SAMFIND_MODLOG_IS_ON ?
		function(s, e)
		{
			dump("\n[samfind]: " + s + ": EXCEPTION: " + e.name + ", " + e.message);
		}
		:
		function(s, e)
		{
		},

	dump_interfaces : SAMFIND_MODLOG_IS_ON ?
		function(c)
		{
			for each (var i in Components.interfaces)
			{
				if (c instanceof i)
				{
					dump("\n" + i);
				}
			}
		}
		:
		function(c)
		{
		},

	_start : null,

	dump_start : SAMFIND_MODLOG_IS_ON ?
		function(s)
		{
			if (s && s.length)
			{
				dump("\n[samfind]: " + s);
			}
			this._start = (new Date()).getTime();
		}
		:
		function(s)
		{
		},

	dump_end : SAMFIND_MODLOG_IS_ON ?
		function(s)
		{
			dump("\n[samfind]: " + s + " (time = " + ((new Date()).getTime() - this._start) + "ms)");
		}
		:
		function(s)
		{
		},

	_dump : function(s)
	{
		dump("\n[samfind]: " + s);
	},

	_dump_exception : function(s, e)
	{
		dump("\n[samfind]: " + s + ": EXCEPTION: " + e.name + ", " + e.message);
	},

	_dump_interfaces : function(c)
	{
		for each (var i in Components.interfaces)
		{
			if (c instanceof i)
			{
				dump("\n" + i);
			}
		}
	},

	_dump_start : function(s)
	{
		if (s && s.length) dump("\n[samfind]: " + s);
		this._start = (new Date()).getTime();
	},

	_dump_end : function(s)
	{
		dump("\n[samfind]: " + s + " (time = " + ((new Date()).getTime() - this._start) + "ms)");
	}
};

/**
 * Constructor.
 */
(function() { this._init(); }).apply(samfind_modlog);