//-------------------------------------------------------------------------------------------
// Social & Bookmarking services module.
//-------------------------------------------------------------------------------------------

const Cc = Components.classes;
const Ci = Components.interfaces;

var EXPORTED_SYMBOLS = ["samfind_modsbservices"];

Components.utils.import("resource://samfind/samfind_modutils.jsm");

var samfind_modsbservices =
{
	_services : null,
	_services_dynamic : null,

	_init : function()
	{
		samfind_modsbservices._services = {
			 aim : "AIM Share",
			 amazon : "Amazon Wishlist",
			 attentionmeter : "AttentionMeter",
			 ballhype : "BallHype",
			 barrapunto : "Barrapunto",
			 bebo : "Bebo",
			 bitly : "bit.ly",
			 bizsugar : "bizSugar",
			 blinklist : "BlinkList",
			 blogger : "Blogger",
			 bloglines : "Bloglines",
			 blogmemesfr : "BlogMemes.fr",
			 bx : "Business Exchange",
			 care2 : "Care2",
			 citeulike : "CiteULike",
			 connotea : "Connotea",
			 current : "Current",
			 delicious : "Delicious",
			 designbump : "Design Bump",
			 designfloat : "Design Float",
			 digg : "Digg",
			 diigo : "Diigo",
			 dotnetkicks : "DotNetKicks",
			 dropjack : "Dropjack",
			 dzone : "DZone",
			 email : "Email this page to a friend",
			 ekudos : "eKudos",
			 evernote : "Evernote",
			 facebook : "Facebook",
			 fark : "Fark",
			 faves : "Faves",
			 followup : "FollowUp",
			 foxiewire : "FoxieWire",
			 fresqui : "Fresqui",
			 fsdaily : "FSDaily",
			 friendfeed : "FriendFeed",
			 funp : "Funp",
			 gabbr : "Gabbr",
			 globalgrind : "Global Grind",
			 gmail : "Gmail",
			 googlebookmarks : "Google Bookmarks",
			 googlenotebook : "Google Notebook",
			 googlereader : "Google Reader",
			 hatena : "Hatena",
			 healthranker : "Health Ranker",
			 hemidemi : "HEMiDEMi",
			 hotmail : "Hotmail",
			 identica : "Identi.ca",
			 indianpad : "IndianPad",
			 instapaper : "Instapaper",
			 isgd : "is.gd",
			 kaboodle : "Kaboodle",
			 kirtsy : "Kirtsy",
			 laterthis : "LaterThis",
			 linkarena : "linkARENA",
			 linkagogo : "linkaGoGo",
			 linkedin : "LinkedIn",
			 live : "Live",
			 livejournal : "LiveJournal",
			 meneame : "Meneame",
			 misterwong : "Mister Wong",
			 mixx : "Mixx",
			 mozillaca : "Mozillaca",
			 multiply : "Multiply",
			 myaol : "MyAOL",
			 myshare : "MyShare",
			 myspace : "MySpace",
			 n4g : "N4G",
			 netvibes : "Netvibes",
			 netvouz : "Netvouz",
			 newsvine : "Newsvine",
			 nujij : "NUjij",
			 oknotizie : "OKNOtizie",
			 picnik : "Picnik",
			 pingfm : "Ping.fm",
			 plurk : "Plurk",
			 posterous : "Posterous",
			 propeller : "Propeller",
			 reddit : "Reddit",
			 scoopeo : "Scoopeo",
			 segnalo : "Segnalo",
			 shoutwire : "ShoutWire",
			 simpy : "Simpy",
			 slashdot : "Slashdot",
			 smaknews : "SmakNews",
			 socialmedian : "socialmedian",
			 socialogs : "Socialogs",
			 soup : "Soup",
			 sphere : "Sphere It!",
			 sphinn : "Sphinn",
			 spurl : "Spurl",
			 squidoo : "Squidoo",
			 streakr : "Streakr",
			 stumble : "Stumble!",
			 stumbleupon : "StumbleUpon - I like this!",
			 stylehive : "Stylehive",
			 supr : "Su.pr",
			 swik : "SWiK",
			 tailrank : "Tailrank",
			 tbuzz : "TBUZZ",
			 technorati : "Technorati",
			 thisnext : "ThisNext",
			 tinyurl : "TinyURL",
			 tipd : "Tip'd",
			 truemors : "Truemors",
			 tumblr : "Tumblr",
			 twackle : "Twackle",
			 twine : "Twine",
			 twitter : "Twitter",
			 viadeo : "Viadeo",
			 visualize : "vi.sualize.us",
			 weheartit : "We heart it",
			 wikio : "Wikio",
			 wists : "Wists",
			 wordpress : "WordPress",
			 xanga : "Xanga",
			 xerpi : "Xerpi",
			 yahoobookmarks : "Yahoo! Bookmarks",
			 yahoobuzz : "Yahoo! Buzz",
			 yammer : "Yammer",
			 ycombinator : "Y Combinator",
			 yigg : "YiGG"
		};
		samfind_modsbservices._services_dynamic = new Array("delicious","digg","reddit");
  	},

	share : function(service)
	{
		var win = samfind_modutils.getWindow();
		//
		var location;
		try
		{
			location = win.content.location.href;
		}
		catch (e)
		{
			return;
		}
		if (location.indexOf("http://www.stumbleupon.com/toolbar/#url=") == 0)
		{
			location = location.substring("http://www.stumbleupon.com/toolbar/#url=".length).replace("%2525253A",":");
		}
		location = encodeURIComponent(location);
		//
		var title = "";
		try
		{
			title = win.content.document.title;
		}
		catch (e)
		{}
		if (title.length)
		{
			if (title.indexOf("StumbleUpon WebToolbar - ") == 0)
			{
				title = title.substring("StumbleUpon WebToolbar - ".length);	
			}
			title = encodeURIComponent(title);
		}
		//
		var selection = win.getBrowserSelection();
		if (selection.length)
		{
			selection = encodeURIComponent(selection);
		}
		//
		var url = null;
		//
		switch (service)
		{
			case "aim":
				{
					url = "http://share.aim.com/share/?url=" + location + "&title=" + title;
				}
				break;
			case "amazon":
				{
					url = "http://www.amazon.com/wishlist/add?u=" + location + "&t=" + title;
				}
				break;
			case "attentionmeter":
				{
				    win.getBrowser().loadURI("javascript:var%20s=document.createElement('script');s.src='http://www.attentionmeter.com/am_bookmarklet.js';s.type='text/javascript';void(document.getElementsByTagName('head')[0].appendChild(s));");
				}
				break;
			case "ballhype":
				{
					url = "http://ballhype.com/post/url/?url=" + location + "&title=" + title;
				}
				break;
			case "barrapunto":
				{
					url = "http://barrapunto.com/submit.pl?subj=" + title + "&story=" + location;
				}
				break;
			case "bebo":
				{
					url = "http://www.bebo.com/c/share?Url=" + location + "&Title=" + title;
				}
				break;
			case "bitly":
				{
					selection = selection.length ? ("%22" + selection + "%22") : "";
					url = "http://bit.ly/?v=3&u=" + location + "&s=" + title + "%20" + selection;
				}
				break;
			case "bizsugar":
				{
					url = "http://www.bizsugar.com/submit.php?url=" + location;
				}
				break;
			case "blinklist":
				{
					url = "http://blinklist.com/blink?u=" + location + "&t=" + title + "&d=" + selection + "&v=2";
				}
				break;
			case "blogger":
				{
					url = "http://www.blogger.com/blog_this.pyra?u=" + location + "&n=" + title + "&t=" + selection;
				}
				break;
			case "bloglines":
				{
					url = "http://www.bloglines.com/sub/" + win.content.location.href;
				}
				break;
			case "blogmemesfr":
				{
					url = "http://www.blogmemes.fr/post.php?url=" + location + "&title=" + title;
				}
				break;
			case "bx":
				{
					url = "http://bx.businessweek.com/api/add-article-to-bx.tn?url=" + location;
				}
				break;
			case "care2":
				{
					url = "http://www.care2.com/news/compose?share[link_url]=" + location + "&share[title]=" + title;
				}
				break;
			case "citeulike":
				{
					url = "http://www.citeulike.org/posturl?bml=nopopup&url=" + location + "&title=" + title;
				}
				break;
			case "connotea":
				{
					url = "http://www.connotea.org/add?continue=return&uri=" + location + "&title=" + title + "&description=" + selection;
				}
				break;
			case "current":
				{
					url = "http://current.com/clipper.htm?url=" + location + "&title=" + title;
				}
				break;
			case "designbump":
				{
					url = "http://designbump.com/node/add/drigg?url=" + location;
				}
				break;
			case "designfloat":
				{
					url = "http://designfloat.com/submit.php?url=" + win.content.location.href;
				}
				break;
			case "delicious":
				{
					url = "http://delicious.com/save?url=" + location + "&title=" + title + "&notes=" + selection + "&jump=yes";
				}
				break;
			case "digg":
				{
					url = "http://digg.com/submit?phase=2&url=" + location + "&title=" + title + "&bodytext=" + selection;
				}
				break;
			case "diigo":
				{
					win.content.document.location = "http://www.diigo.com/post?url=" + location + "&title=" + title + "&desc=" + selection;
					win.content.focus();
				}
				break;
			case "dotnetkicks":
				{
					url = "http://www.dotnetkicks.com/kick/?url=" + location + "&title=" + title;
				}
				break;
			case "dropjack":
				{
					url = "http://www.dropjack.com/submit.php?url=" + location + "&title=" + title;
				}
				break;
			case "dzone":
				{
					url = "http://www.dzone.com/links/add.html?url=" + location + "&title=" + title;
				}
				break;
			case "ekudos":
				{
					url = "http://www.ekudos.nl/artikel/nieuw?url=" + location + "&title=" + title + "&desc=" + selection;
				}
				break;
			case "evernote":
				{
					win.getBrowser().loadURI("javascript:(function(){EN_CLIP_HOST='http://www.evernote.com';try{var%20x=document.createElement('SCRIPT');x.type='text/javascript';x.src=EN_CLIP_HOST+'/public/bookmarkClipper.js?'+(new%20Date().getTime()/100000);document.getElementsByTagName('head')[0].appendChild(x);}catch(e){location.href=EN_CLIP_HOST+'/clip.action?url='+encodeURIComponent(location.href)+'&title='+encodeURIComponent(document.title);}})();");
				}
				break;
			case "facebook":
				{
					url = "http://www.facebook.com/share.php?u=" + location + "&t=" + title;
				}
				break;
			case "fark":
				{
					url = "http://cgi.fark.com/cgi/fark/farkit.pl?u=" + location + "&h=" + title;
				}
				break;
			case "faves":
				{
					win.getBrowser().loadURI("javascript:{var%20w=window;w.l=w.location;w.SdP='secure.';w.bU=(w.l.protocol=='https:'?'https://'+w.SdP:'http://')+'faves.com';w.eUC=encodeURIComponent;function%20fBkF(){w.l.href=w.bU+'/Authoring.aspx?u='+w.eUC(w.l.href)+'&t='+w.eUC(document.title);}w.gT=w.setTimeout(fBkF,6999);w.d=w.document;w.sT=w.d.body;w.o=w.d.createElement('scri'+'pt');if(typeof%20w.o!='object')fBkF();w.o.setAttribute('src',w.bU+'/js/Authoring.js');w.o.setAttribute('type','text/javascript');void(w.sT.appendChild(w.o));}");
				}
				break;
			case "followup":
				{
					url = "http://www.followup.cc/bookmark.php?url=" + location + "&title=" + title;
				}
				break;
			case "foxiewire":
				{
					url = "http://www.foxiewire.com/?q=submit&url=" + location + "&title=" + title + "&body=" + selection;
				}
				break;
			case "fresqui":
				{
					url = "http://fresqui.com/enviar?url=" + location + "&title=" + title;
				}
				break;
			case "fsdaily":
				{
					url = "http://www.fsdaily.com/submit?url=" + location + "&title=" + title;
				}
				break;
			case "friendfeed":
				{
					win.getBrowser().loadURI("javascript:void((function(){var%20e=document.createElement('script');e.setAttribute('type','text/javascript');e.setAttribute('src','http://friendfeed.com/share/bookmarklet/javascript');document.body.appendChild(e)})())");
				}
				break;
			case "funp":
				{
					url = "http://funp.com/pages/submit/add.php?title=" + title + "&url=" + location;
				}
				break;
			case "gabbr":
				{
					url = "http://www.gabbr.com/submit/?bookurl=" + location;
				}
				break;
			case "globalgrind":
				{			
					url = "http://globalgrind.com/submission/submit.aspx?url=" + location + "&type=Article&title=" + title;
				}
				break;
			case "gmail":
				{
					url = "http://mail.google.com/mail/?ui=1&view=cm&fs=1&tf=1&to=&su=" + title + "&body=Link: " + location + "%0D%0A%0D%0A" + selection + "%0D%0A%0D%0A" + "%28via samfind Bookmarks Bar%29";
				}
				break;
			case "googlebookmarks":
				{
					url = "http://www.google.com/bookmarks/mark?op=edit&bkmk=" + location + "&title=" + title;
				}
				break;
			case "googlenotebook":
				{
					win.getBrowser().loadURI("javascript:(function(){var%20w=window;var%20d=document;var%20g=w.open('about:blank','gnotesWin','location=0,menubar=0,scrollbars=0,status=0,toolbar=0,width=300,height=300,resizable=1');var%20s=d.createElement('script');s.setAttribute('src','http://www.google.com/notebook/bookmarkletPoster?zx='+(new%20Date()).valueOf());d.body.appendChild(s);w.setTimeout(function(){w.blur();g.focus();},%20100)}).call({});");
				}
				break;
			case "googlereader":
				{
					win.getBrowser().loadURI(
"javascript:var%20b=document.body;var%20GR________bookmarklet_domain='https://www.google.com';if(b&&!document.xmlVersion){void(z=document.createElement('script'));void(z.src='https://www.google.com/reader/ui/link-bookmarklet.js');void(b.appendChild(z));}else{}");
				}
				break;
			case "hatena":
				{
					url = "http://b.hatena.ne.jp/bookmarklet?url=" + location + "&btitle=" + title;
				}
				break;
			case "healthranker":
				{
					url = "http://www.healthranker.com/submit.php?url=" + location + "&title=" + title;
				}
				break;
			case "hemidemi":
				{
					url = "http://www.hemidemi.com/user_bookmark/new?title=" + title + "&url=" + location + "&description=" + selection + "&via=samfind%20Bookmarks%20Bar";
				}
				break;
			case "hotmail":
				{
					url = "http://mail.live.com/default.aspx?rru=compose%3Fsubject%3D" + encodeURIComponent(escape(win.content.document.title)) + "%26body%3DLink: " + encodeURIComponent(escape(win.content.location.href)) + "%0D%0A%0D%0A" + encodeURIComponent(escape(win.getBrowserSelection())) + "%0D%0A%0D%0A" + "%28via samfind Bookmarks Bar%29";
				}
				break;
			case "indianpad":
				{
					url = "http://www.indianpad.com/submit.php?url=" + location;
				}
				break;
			case "instapaper":
				{
					url = "http://www.instapaper.com/b?u=" + location + "&t=" + title;
				}
				break;
			case "isgd":
				{
					url = "http://is.gd/create.php?longurl=" + location;
				}
				break;
			case "kaboodle":
				{
					url = "http://www.kaboodle.com/za/selectpage?p_pop=false&pa=url&u=" + location;
				}
				break;
			case "kirtsy":
				{
					url = "http://www.kirtsy.com/submit.php?url=" + location;
				}
				break;
			case "linkagogo":
				{
					url = "http://www.linkagogo.com/go/AddNoPopup?url=" + location + "&title=" + title + "&comments=" + selection;
				}
				break;
			case "laterthis":
				{
					win.content.document.location = "http://laterthis.com/post?stand_alone=true&link_url=" + location + "&link_title=" + title + "&link_comment=" + selection;
					win.content.focus();
				}
				break;
			case "linkarena":
				{
					url = "http://linkarena.com/bookmarks/addlink/?url=" + location + "&title=" + title;
				}
				break;
			case "linkedin":
				{
					url = "http://www.linkedin.com/shareArticle?url=" + location + "&title=" + title + "&summary=" + selection + "&source=Posted via samfind Bookmarks Bar";
				}
				break;
			case "live":
				{	
					win.content.document.location = "https://favorites.live.com/quickadd.aspx?marklet=1&mkt=en-us&url=" + location + "&title=" + title;
				}
				break;
			case "livejournal":
				{
					url = "http://www.livejournal.com/update.bml?subject=" + title + "&event=" + location + escape(" (via samfind Bookmarks Bar) \n\n") + selection;
				}
				break;
			case "meneame":
				{
					url = "http://meneame.net/submit.php?url=" + location + "&title=" + title;
				}
				break;
			case "misterwong":
				{
					url = "http://www.mister-wong.com/index.php?action=addurl&bm_url=" + location + "&bm_description=" + title;
				}
				break;
			case "mixx":
				{
					url = "http://www.mixx.com/submit?page_url=" + location;
				}
				break;
			case "mozillaca":
				{
					url = "http://mozillaca.com/index.php?action=newnotice&status_textarea=\"" + title + "\" from " + location;
				}
				break;
			case "multiply":
				{
					url = "http://multiply.com/gus/journal/compose/?url=" + location + "&subject=" + title + "&body=" + selection;
				}
				break;
			case "myaol":
				{
					url = "http://favorites.my.aol.com/ffclient/AddBookmark?url=" + location + "&title=" + title + "&favelet=true";
				}
				break;
			case "myshare":
				{
					url = "http://myshare.url.com.tw/index.php?func=newurl&url=" + location + "&desc=" + title;
				}
				break;
			case "myspace":
				{
					url = "http://www.myspace.com/Modules/PostTo/Pages/?l=3&u=" + location + "&t=" + title + "&c=" + selection + "<p>Posted via <a href=\"https://addons.mozilla.org/en-US/firefox/addon/9866\">samfind Bookmarks Bar</a></p>";
				}
				break;
			case "n4g":
				{
					url = "http://www.n4g.com/tips.aspx?url=" + location + "&title=" + title;
				}
				break;
			case "netvibes":
				{
					url = "http://www.netvibes.com/share?url=" + location + "&title=" + title;
				}
				break;
			case "netvouz":
				{
					url = "http://netvouz.com/action/submitBookmark?url=" + location + "&title=" + title;
				}
				break;
			case "newsvine":
				{
					url = "http://www.newsvine.com/_tools/seed&save?u=" + location + "&h=" + title;
				}
				break;
			case "nujij":
				{
					url = "http://nujij.nl/jij.lynkx?t=" + title + "&u=" + location + "&b=" + selection;
				}
				break;
			case "oknotizie":
				{
					url = "http://oknotizie.alice.it/post?url=" + location + "&title=" + title;
				}
				break;
			case "picnik":
				{
					url = "http://www.picnik.com/?import=" + location;
				}
				break;
			case "pingfm":
				{
					url = "http://ping.fm/ref/?link=" + location + "&title=" + title;
				}
				break;
			case "plurk":
				{
					url = "http://www.plurk.com/m?content=" + location + "&qualifier=shares";
				}
				break;
			case "posterous":
				{
					win.getBrowser().loadURI("javascript:var%20b=document.body;var%20POSTEROUS___bookmarklet_domain='http://posterous.com';if(b&&!document.xmlVersion){void(z=document.createElement('script'));void(z.type='text/javascript');void(z.src='http://posterous.com/javascripts/bookmarklet2.js');void(b.appendChild(z));}else{}");
				}
				break;
			case "propeller":
				{
					url = "http://www.propeller.com/story/submit/?url=" + location + "&title=" + title;
				}
				break;
			case "reddit":
				{
					url = "http://reddit.com/submit?url=" + location + "&title=" + title;
				}
				break;
			case "scoopeo":
				{
					url = "http://www.scoopeo.com/scoop/new?newurl=" + location + "&title=" + title + "&content=" + selection;
				}
				break;
			case "segnalo":
				{
					url = "http://segnalo.virgilio.it/post.html.php?url=" + location + "&title=" + title +"&descr" + selection;
				}
				break;
			case "shoutwire":
				{
					url = "http://www.shoutwire.com/?p=submit&link=" + location;
				}
				break;
			case "simpy":
				{
					url = "http://www.simpy.com/simpy/LinkAdd.do?href=" + location + "&title=" + title + "&note=" + selection + "&src=bookmarklet";
				}
				break;
			case "slashdot":
				{
					url = "http://slashdot.org/slashdot-it.pl?op=basic&url=" + location;
				}
				break;
			case "smaknews":
				{
					url = "http://smaknews.com/submit.php?url=" + location;
				}
				break;
			case "socialmedian":
				{
					url = "http://www.socialmedian.com/bookmarker?u=" + location + "&t=" + title + "&s=" + selection;
				}
				break;
			case "socialogs":
				{
					url = "http://socialogs.com/add_story.php?story_url=" + location + "&story_title=" + title + "&story_desc=" + selection;
				}
				break;
			case "soup":
				{
					var d = win.content.document;
					var di = win.content.document.images;
					var dom = win.content.document.location.href.match(/(.*)\/.*$/)[1];
					var i = '';
					for (var n=0; n<di.length; n++)
					{
						if (di[n].offsetWidth*di[n].offsetHeight > 1400)
						{
							i += di[n].src.replace(dom, '@@') + '|' + di[n].offsetWidth + '|' + di[n].offsetHeight +',';
						}
					}
					url = "http://www.soup.io/bookmarklet?v=5&u=" + location + "&t=" + title + "&s=" + location + "&dom=" + encodeURIComponent(dom) + "&i=" + encodeURIComponent(i);
				}
				break;
			case "sphere":
				{
					url = "http://www.sphere.com/search/blogs/?q=sphereit:" + location + "&title=" + title;
				}
				break;
			case "sphinn":
				{
					url = "http://sphinn.com/submit.php?url=" + location + "&title=" + title;
				}
				break;
			case "spurl":
				{
					url = "http://www.spurl.net/spurl.php?url=" + location + "&title=" + title;
				}
				break;
			case "squidoo":
				{
					url = "http://www.squidoo.com/lensmaster/bookmark?" + location;
				}
				break;
			case "streakr":
				{
					url = "http://www.streakr.com/mystreakr/emailfriend.aspx?SiteURL=" + location;
				}
				break;
			case "stumble":
				{
					url = "http://www.stumbleupon.com/toolbar/";
				}
				break;
			case "stumbleupon":
				{
					url = "http://www.stumbleupon.com/submit?url=" + location + "&title=" + title;
				}
				break;
			case "stylehive":
				{
					url = "http://www.stylehive.com/savebookmark/index.htm?url=" + location;
				}
				break;
			case "supr":
				{
					win.getBrowser().loadURI("javascript:var%20e=document.createElement('script');e.setAttribute('type','text/javascript');e.setAttribute('src','http://su.pr/supr_shortcut.php?action=js_post');document.body.appendChild(e);void(0);");
				}
				break;
			case "swik":
				{
					url = "http://stories.swik.net/?bookmarklet=v1&submitUrl&url=" + location + "&title=" + title + "&description=" + selection;
				}
				break;
			case "tailrank":
				{
					url = "http://tailrank.com/share/?link_href=" + location + "&title=" + title;
				}
				break;
			case "tbuzz":
				{
					win.getBrowser().loadURI("javascript:(function(){_tbuzz_css=document.createElement('LINK');_tbuzz_css.rel='stylesheet';_tbuzz_css.href='http://tbuzz.arc90.com/css/tbuzz';_tbuzz_css.href+=(document.all%20&&%20!window.opera%20&&%20window.XMLHttpRequest%20&&%20document.compatMode!='CSS1Compat')%20?%20'IE7.css?x='%20:%20'.css?x=';_tbuzz_css.href+=(Math.random());_tbuzz_css.type='text/css';document.getElementsByTagName('head')[0].appendChild(_tbuzz_css);_tbuzz_script=document.createElement('SCRIPT');_tbuzz_script.type='text/javascript';_tbuzz_script.src='http://tbuzz.arc90.com/js/tbuzz.bookmarklet.js?x='+(Math.random());document.getElementsByTagName('head')[0].appendChild(_tbuzz_script);})();");
				}
				break;
			case "technorati":
				{
					url = "http://technorati.com/faves?add=" + location;
				}
				break;
			case "thisnext":
				{
					url = "http://www.thisnext.com/pick/new/submit/sociable/?url=" + location + "&name=" + title;
				}
				break;
			case "tinyurl":
				{
					url = "http://tinyurl.com/create.php?url=" + location;
				}
				break;
			case "tipd":
				{
					url = "http://tipd.com/submit.php?url=" + location;
				}
				break;
			case "truemors":
				{
					url = "http://truemors.nowpublic.com/post/?headline=" + title + "&truemor=" + selection + "%0D%0D%0A%3Ca href=%22" + location + "%22%3E%3C/a%3E";
				}
				break;
			case "tumblr":
				{
					url = "http://www.tumblr.com/share?v=3&u=" + location + "&t=" + title + "&s=" + selection;
				}
				break;
			case "twackle":
				{	
					url = "http://www.twackle.com/chicklet?site=" + location;
				}
				break;
			case "twine":
				{	
					url = "http://www.twine.com/bookmark/basic?u=" + location + "&t=" + title + "&v=3";
				}
				break;
			case "viadeo":
				{
					url = "http://www.viadeo.com/shareit/share/?url=" + loation + "&title=" + title + "&encoding=UTF-8";
				}
				break;
			case "visualize":
				{
					win.getBrowser().loadURI("javascript:(function(){function%20l(u,i){var%20d=document;if(!d.getElementById(i)){var%20s=d.createElement('script');s.src=u;s.id=i;d.body.appendChild(s);}}l('http://vi.sualize.us/js/visualizeus.js','visualizeus')})();");
				}
				break;
			case "weheartit":
				{
					win.getBrowser().loadURI("javascript:void((function(){var%20e=document.createElement('script');e.setAttribute('type','text/javascript');e.setAttribute('charset','UTF-8');e.setAttribute('src','http://weheartit.com/bookmarklet.js');document.body.appendChild(e)})());");
				}
				break;
			case "wikio":
				{
					url = "http://www.wikio.com/sharethis?url=" + location + "&title=" + title;
				}
				break;
			case "wists":
				{
					url = "http://wists.com/u.php?r=" + location + "&t=" + title;
				}
				break;
			case "wordpress":
				{
					win.getBrowser().loadURI("javascript:var%20d=document,w=window,e=w.getSelection,k=d.getSelection,x=d.selection,s=(e?e():(k)?k():(x?x.createRange().text:0)),f='https://newsdrag.wordpress.com/wp-admin/press-this.php',l=d.location,e=encodeURIComponent,g=f+'?u='+e(l.href)+'&t='+e(d.title)+'&s='+e(s)+'&v=2';function%20a(){if(!w.open(g,'t','toolbar=0,resizable=0,scrollbars=1,status=1,width=720,height=620,left=" + ((win.screen.availWidth - 720) / 2) + ",top=" + ((win.screen.availHeight - 620) / 2) + "')){l.href=g;}}setTimeout(a,0);void(0);");
				}
				break;
			case "xanga":
				{
					url = "http://www.xanga.com/private/editorx.aspx?u=" + location + "&t=" + title;
				}
				break;
			case "xerpi":
				{
					url = "http://www.xerpi.com/favorite/post?url=" + location + "&title=" + title;
				}
				break;
			case "yahoobookmarks":
				{
					url = "http://bookmarks.yahoo.com/toolbar/savebm?u=" + location + "&t=" + title + "&d=" + selection + "&opener=bm&ei=UTF-8";
				}
				break;
			case "yahoobuzz":
				{
					url = "http://buzz.yahoo.com/buzz?targetUrl=" + location + "&headline=" + title + "&summary=" + selection;
				}
				break;
			case "yammer":
				{
					url = "http://www.yammer.com/home/bookmarklet?bookmarklet_pop=0&v=1&u=" + location + "&t=" + title + "&s=" + selection;
				}
				break;
			case "ycombinator":
				{
					url = "http://news.ycombinator.com/submitlink?u=" + location + "&t=" + title;
				}
				break;
			case "yigg":
				{
					url = "http://www.yigg.de/neu?exturl=" + location + "&exttitle=" + title;
				}
				break;
		}
		//
		if (url != null)
		{
			samfind_modutils.openTab(url, null);
		}
	}
};

/**
 * Constructor.
 */
(function() { this._init(); }).apply(samfind_modsbservices);